#include "stdafx.h"
#include "ooapi.h"
#include "windows.h"


__fastcall OOAPI3::OOAPI3() {
  // 
  HMODULE hLib = LoadLibrary(L"ooapi3.dll");
  if(hLib == NULL) {
        throw;
  }

	//CALC
	(FARPROC &)ooConnect2Calc     = GetProcAddress(hLib, "connect2Calc");
	(FARPROC &)ooDisconect        = GetProcAddress(hLib, "disconnect");
	(FARPROC &)ooSelectSheet      = GetProcAddress(hLib, "selectSheet");
	(FARPROC &)ooSetVal           = GetProcAddress(hLib, "setVal");
	(FARPROC &)ooSetFormula       = GetProcAddress(hLib, "setText");
	(FARPROC &)ooSetBold          = GetProcAddress(hLib, "setBold");
	(FARPROC &)ooSetFontColor     = GetProcAddress(hLib, "setFontColor");
	(FARPROC &)ooSetBgColor       = GetProcAddress(hLib, "setBgColor");
	(FARPROC &)ooSetFontSize      = GetProcAddress(hLib, "setFontSize");
	(FARPROC &)ooSetItalic        = GetProcAddress(hLib, "setItalic");
	(FARPROC &)ooSetHoriz         = GetProcAddress(hLib, "setHoriz");
	(FARPROC &)ooSetBorders       = GetProcAddress(hLib, "setBorders");
	(FARPROC &)ooSetColWidth      = GetProcAddress(hLib, "setColWidth");
	(FARPROC &)ooMergeRange       = GetProcAddress(hLib, "mergeRange");
	(FARPROC &)ooExportToUrl      = GetProcAddress(hLib, "exportToUrl");
	(FARPROC &)ooGetVal           = GetProcAddress(hLib, "getVal");
	(FARPROC &)ooGetText          = GetProcAddress(hLib, "getText");
	(FARPROC &)ooIsWin            = GetProcAddress(hLib, "isWin");
	(FARPROC &)ooIsInstall        = GetProcAddress(hLib, "isInstall");
	(FARPROC &)ooGetFontName      = GetProcAddress(hLib, "getFontName");
	(FARPROC &)ooSetFont4Cell     = GetProcAddress(hLib, "setFont4Cell");
	(FARPROC &)ooSetFont4Col      = GetProcAddress(hLib, "setFont4Col");
	(FARPROC &)ooSetWrapped       = GetProcAddress(hLib, "setWrapped");
	(FARPROC &)ooSetCellStyle     = GetProcAddress(hLib, "setCellStyle");
	(FARPROC &)ooSetColStyle      = GetProcAddress(hLib, "setColStyle");
	(FARPROC &)ooSetOverline      = GetProcAddress(hLib, "setOverline");
	(FARPROC &)ooSetUnderline     = GetProcAddress(hLib, "setUnderline");
	(FARPROC &)ooSetStrikeout     = GetProcAddress(hLib, "setStrikeout");
	(FARPROC &)ooPrintDocument    = GetProcAddress(hLib, "printDocument");
	(FARPROC &)ooCloseDocument	  = GetProcAddress(hLib, "closeDocument");
	(FARPROC &)ooGetSheetCount	  = GetProcAddress(hLib, "getSheetCount");
	(FARPROC &)ooInsertSheet	  = GetProcAddress(hLib, "insertSheet");
	(FARPROC &)ooGetSheetByName	  = GetProcAddress(hLib, "getSheetByName");
	(FARPROC &)ooGetSheetById	  = GetProcAddress(hLib, "getSheetById");
	(FARPROC &)ooDelSheetByName	  = GetProcAddress(hLib, "delSheetByName");
	(FARPROC &)ooDelSheetById	  = GetProcAddress(hLib, "delSheetById");
	(FARPROC &)ooSetActiveSheet	  = GetProcAddress(hLib, "setActiveSheet");

	(FARPROC &)ooGetWrapped		  = GetProcAddress(hLib, "getWrapped");
	(FARPROC &)ooGetCellStyle	  = GetProcAddress(hLib, "getCellStyle");
	(FARPROC &)ooGetOverline	  = GetProcAddress(hLib, "getOverline");
	(FARPROC &)ooGetUnderline	  = GetProcAddress(hLib, "getUnderline");
	(FARPROC &)ooGetStrikeout	  = GetProcAddress(hLib, "getStrikeout");
	(FARPROC &)ooInsertImage	  = GetProcAddress(hLib, "insertImage");
	(FARPROC &)ooModifyImage	  = GetProcAddress(hLib, "modifyImage");
	(FARPROC &)ooModifyImageById  = GetProcAddress(hLib, "modifyImageById");
	(FARPROC &)ooGetImageCount    = GetProcAddress(hLib, "getImageCount");
	(FARPROC &)ooGetImageSize    = GetProcAddress(hLib, "getImageSize");
	(FARPROC &)ooGetImagePosition = GetProcAddress(hLib, "getImagePosition");
	(FARPROC &)ooSetVerticalAlignment = GetProcAddress(hLib, "setVerticalAlignment");


	//WRITER
	(FARPROC &)ooConnect2Writer   = GetProcAddress(hLib, "connect2Writer");
	(FARPROC &)ooGetWText		  = GetProcAddress(hLib, "getWText");
	(FARPROC &)ooSetWText		  = GetProcAddress(hLib, "setWText");
	(FARPROC &)ooExport2Writer	  = GetProcAddress(hLib, "exportWToUrl");
	(FARPROC &)ooCreateTextTable  = GetProcAddress(hLib, "createTextTable");



	//IMPRESS
	(FARPROC &)ooConnect2Impress  = GetProcAddress(hLib, "connect2Impress");
	(FARPROC &)ooExport2Impress   = GetProcAddress(hLib, "exportIToUrl");

}

bool __fastcall OOAPI3::connect2Calc(const char* file, char * host, char * port, bool hidden, char * key) 
{
  // file:///  

  return ooConnect2Calc(file, host, port, hidden, key);
}

bool __fastcall OOAPI3::connect2Writer(char* file, char * host, char * port, bool hidden, char * key) 
{
  // file:///  

  return ooConnect2Writer(file,host,port,hidden,key);
}

bool __fastcall OOAPI3::setSheet(short sheet) 
{
  return ooSelectSheet(sheet);
}

void __fastcall OOAPI3::setVal(int x, int y, double val) 
{
  ooSetVal(x, y, val);
}

void __fastcall OOAPI3::setText(int x, int y, char * val)
{
	ooSetFormula(x, y, val);
}

bool __fastcall OOAPI3::setBold(int x, int y) 
{
  return ooSetBold(x, y);
}

bool __fastcall OOAPI3::setItalic(int x, int y) 
{
  return ooSetItalic(x, y);
}

bool __fastcall OOAPI3::setFontColor(int x, int y, int r, int g, int b) 
{
  //TODO:     > 0, < 255
  return ooSetFontColor(x, y, r, g, b);
}

bool __fastcall OOAPI3::setBgColor(int x, int y, int r, int g, int b) 
{
  return ooSetBgColor(x, y, r, g, b);
}

bool __fastcall OOAPI3::setFontSize(int x, int y, short size) 
{
  return ooSetFontSize(x, y, size);
}

//  
//1 - , 2 - , 3 - 
bool __fastcall OOAPI3::setHoriz(int x, int y, short horiz) 
{
  //TODO: - 
  return ooSetHoriz(x, y, horiz);
}

//  
//, , , , r, g, b
bool __fastcall OOAPI3::setBorders(int x, int y, bool l, bool t, bool r, bool d, short rd, short gr, short bl) 
{
  return ooSetBorders(x, y, l, t, r, d, rd, gr, bl);
}

//  
//, , , 
bool __fastcall OOAPI3::setBorders(int x, int y, bool l, bool t, bool r, bool d) 
{
  // 
  return ooSetBorders(x, y, l, t, r, d, 0, 0, 0);
}

//  
//  
bool __fastcall OOAPI3::setBorders(int x, int y) 
{
  return ooSetBorders(x, y, true, true, true, true, 0, 0, 0);
}

bool __fastcall OOAPI3::setColWidth(int col, long mm) 
{
  return ooSetColWidth(col, mm);
}

//  
//  A1:C7
bool __fastcall OOAPI3::mergeRange(char * from, char * to) 
{
	return ooMergeRange(from, to);
}

//: file:///C:/.xls
bool __fastcall OOAPI3::export2XLS(char * file) 
{
	return ooExportToUrl(file);
}

//   
double   __fastcall OOAPI3::getVal(int x, int y) 
{
  return ooGetVal(x, y);
}

//  
char * __fastcall OOAPI3::getText(int x, int y) 
{
  return (char *)ooGetText(x, y);
}

bool  __fastcall OOAPI3::isWin() 
{
  return ooIsWin();
}

//   ?
bool __fastcall OOAPI3::isInstall() 
{
  return ooIsInstall();
}

char * __fastcall OOAPI3::getFontName( int x, int y )
{
	return ooGetFontName(x,y);
}

void OOAPI3::setFont4Cell( int x, int y, char * fontName )
{
	return ooSetFont4Cell( x, y, fontName );
}

void OOAPI3::setFont4Col(int col, char * fontName )
{
	return ooSetFont4Col( col, fontName );
}

void OOAPI3::setWrapped(int x, int y, bool bWrapped )
{
	return ooSetWrapped(x,y,bWrapped);
}

void OOAPI3::setCellStyle( int x, int y, long lStyle )
{
	return ooSetCellStyle(x,y,lStyle);
}

void OOAPI3::setColStyle( int col, long lStyle )
{
	return ooSetColStyle(col,lStyle);
} 

void OOAPI3::setOverline(int x, int y, bool bOverline )
{
	return ooSetOverline(x,y,bOverline);
}

void OOAPI3::setUnderline(int x, int y, bool bUnderline )
{
	return ooSetUnderline(x,y,bUnderline);
}

void OOAPI3::setStrikeout(int x, int y, bool bStrikeout )
{
	return ooSetStrikeout(x,y,bStrikeout);
}

void OOAPI3::printDocument()
{
	return ooPrintDocument();
}

void OOAPI3::closeDocument()
{
	return ooCloseDocument();
}

char * OOAPI3::getWText()
{
	return ooGetWText();
}

void OOAPI3::setWText(char * text, int iStartAt)
{
	return ooSetWText(text,iStartAt);
}

void OOAPI3::createTextTable()
{
	return ooCreateTextTable();
}

long OOAPI3::getSheetCount()
{
	return ooGetSheetCount();
}

void OOAPI3::insertSheet(char * name, long lPos )
{
	return ooInsertSheet( name, lPos );
}

long OOAPI3::getSheetByName( char * name )
{
	return ooGetSheetByName(name);
}

char * OOAPI3::getSheetById( long id )
{
	return ooGetSheetById( id );
}

void OOAPI3::delSheetByName(char * name)
{
	return ooDelSheetByName( name );
}

void OOAPI3::delSheetById( long id )
{
	return ooDelSheetById( id );
}

void OOAPI3::setActiveSheet( long id )
{
	return ooSetActiveSheet( id );
}

bool OOAPI3::getWrapped( int x, int y )
{
	return ooGetWrapped(x,y);
}

int OOAPI3::getCellStyle(int x, int y)
{
	return ooGetCellStyle(x,y);
}
bool OOAPI3::getOverline(int x, int y)
{
	return ooGetOverline(x,y);
}
bool OOAPI3::getUnderline(int x, int y)
{
	return ooGetUnderline(x,y);
}
bool OOAPI3::getStrikeout(int x, int y)
{
	return ooGetStrikeout(x,y);
}

void OOAPI3::insertImage(imgPosition iPos, imgSize iSize, char * imgUrl)
{
	return ooInsertImage(iPos,iSize,imgUrl);
}

void OOAPI3::modifyImage(char * shapeName, imgPosition iPos, imgSize iSize)
{
	return ooModifyImage(shapeName,iPos,iSize);
}

int OOAPI3::getImageCount( int iSheet )
{
	return ooGetImageCount( iSheet );
	//if iSheet = -1, then used sheet selected by SelectSheet( int sheet )
}

void OOAPI3::modifyImageById( int id, imgPosition iPos, imgSize iSize )
{
	return ooModifyImageById(id,iPos,iSize);
}
imgSize OOAPI3::getImageSize( int id )
{
	return ooGetImageSize(id);
}
imgPosition OOAPI3::getImagePosition( int id )
{
	return ooGetImagePosition(id);
}

bool OOAPI3::setVerticalAlignment(int x, int y, short vert)
{
	return ooSetVerticalAlignment(x,y,vert);
}

bool __fastcall OOAPI3::export2Writer(char * file) 
{
	return ooExport2Writer(file);
}

bool __fastcall OOAPI3::export2Impress(char * file) 
{
	return ooExport2Impress(file);
}

bool __fastcall OOAPI3::connect2Impress(char* file, char * host, char * port, bool hidden, char * key) 
{
  // file:///  

  return ooConnect2Impress(file,host,port,hidden,key);
}

//  ,  
__fastcall OOAPI3::~OOAPI3() {
  ooDisconect();
  FreeLibrary((HMODULE)hLib);
}


