#ifndef ooapi3H
#define ooapi3H

#include <windows.h>
#include "ooapi_include.h"
#include "OOAPI_Defines.h"
// <vcl.h>
//#include "StrUtils.hpp"

class OOAPI3 {
   private:
      HANDLE hLib;
      
   protected:
      ///CALC
      bool (*ooConnect2Calc)(const char *, char *, char *, bool, char *);
      void (*ooDisconect)();
      bool (*ooSelectSheet)(short);
      void (*ooSetVal)(int, int, double);
      void (*ooSetFormula)(int, int, char *);
      bool (*ooSetBold)(int, int);
      bool (*ooSetFontColor)(int, int, int, int, int);
      bool (*ooSetBgColor)(int, int, int, int, int);
      bool (*ooSetFontSize)(int, int, short);
      bool (*ooSetItalic)(int, int);
      bool (*ooSetHoriz)(int, int, short);
      bool (*ooSetBorders)(int, int, bool, bool, bool, bool, short, short, short);
      bool (*ooSetColWidth)(int, long);
      bool (*ooMergeRange)(const char *, const char *);
      bool (*ooExportToUrl)(char *);
      double   (*ooGetVal)(int, int);
      char* (*ooGetText)(int, int);
      bool (*ooIsInstall)();
      bool (*ooIsWin)();
	  char * (*ooGetFontName)(int,int);
	  void (*ooSetFont4Cell)(int,int,char *);
	  void (*ooSetFont4Col)(int,char *);
	  void (*ooSetWrapped)(int,int,bool);
	  void (*ooSetCellStyle)(int,int,long);
	  void (*ooSetColStyle)(int,long);
	  void (*ooSetOverline)(int,int,bool);
	  void (*ooSetUnderline)(int,int,bool);
	  void (*ooSetStrikeout)(int,int,bool);
	  void (*ooPrintDocument)();
	  void (*ooCloseDocument)();
	  long (*ooGetSheetCount)();
	  void (*ooInsertSheet)(char *, long);
	  long (*ooGetSheetByName)(char *);
	  char *(*ooGetSheetById)(long);
	  void (*ooDelSheetByName)(char *);
	  void (*ooDelSheetById)(long);
	  void (*ooSetActiveSheet)(long);
	  bool (*ooGetWrapped)(int, int);
	  int  (*ooGetCellStyle)(int,int);
	  bool (*ooGetOverline)(int,int);
	  bool (*ooGetUnderline)(int,int);
	  bool (*ooGetStrikeout)(int,int);
	  void (*ooInsertImage)(imgPosition, imgSize, char *);
	  void (*ooModifyImage)(char *, imgPosition, imgSize);
	  int (*ooGetImageCount)(int);
	  void (*ooModifyImageById)(int,imgPosition, imgSize);
	  imgSize (*ooGetImageSize)(int);
	  imgPosition (*ooGetImagePosition)(int);
	  bool (*ooSetVerticalAlignment)(int, int, short);


	  ///WRITER
	  bool (*ooConnect2Writer)(char *, char * , char * , bool , char *);
	  char *(*ooGetWText)();
	  void (*ooSetWText)(char *, int);
	  bool (*ooExport2Writer)(char *);
	  void (*ooCreateTextTable)();


	  ///IMPRESS
	  bool (*ooConnect2Impress)(char *, char * , char * , bool , char *);
	  bool (*ooExport2Impress)(char *);

   public:
        __fastcall OOAPI3();
        __fastcall ~OOAPI3();

		//CALC
        bool __fastcall connect2Calc(const char* file, char * host, char * port, bool hidden, char * key);
        bool __fastcall setSheet(short sheet);
        void __fastcall setVal(int x, int y, double val);
        void __fastcall setText(int x, int y, char * val);
        bool __fastcall setBold(int x, int y);
        bool __fastcall setItalic(int x, int y);
        bool __fastcall setFontColor(int x, int y, int r, int g, int b);
        bool __fastcall setBgColor(int x, int y, int r, int g, int b);
        bool __fastcall setFontSize(int x, int y, short size);
        bool __fastcall setHoriz(int x, int y, short horiz);
        bool __fastcall setBorders(int x, int y, bool l, bool t, bool r, bool d, short rd, short gr, short bl);
        bool __fastcall setBorders(int x, int y, bool l, bool t, bool r, bool d);
        bool __fastcall setBorders(int x, int y);
        bool __fastcall setColWidth(int col, long mm);
        bool __fastcall mergeRange(char * from,char * to);
        bool __fastcall export2XLS(char * file);
        double __fastcall getVal(int x, int y);
        char * __fastcall getText(int x, int y);
        bool __fastcall isWin();
        bool __fastcall isInstall();
		char * __fastcall getFontName(int x, int y);
		void __fastcall setFont4Cell(int x,int y,char *);
		void __fastcall setFont4Col(int col,char *);
		void __fastcall setWrapped(int x, int y, bool bWrapped );
		void __fastcall setCellStyle( int x, int y, long lStyle );
		void __fastcall setColStyle(int col, long lStyle );
		void __fastcall setOverline(int x, int y, bool bOverline);
		void __fastcall setUnderline(int x, int y, bool bUnderline);
		void __fastcall setStrikeout(int x, int y, bool bStrikeout);
		void __fastcall printDocument();
		void __fastcall closeDocument();
		long __fastcall getSheetCount();
		void __fastcall insertSheet(char * name, long lPos = -1);
		long __fastcall getSheetByName(char * name);
		char * __fastcall getSheetById(long id);
		void __fastcall delSheetByName(char * name);
		void __fastcall delSheetById( long id );
		void __fastcall setActiveSheet( long id );
		bool __fastcall	getWrapped( int x, int y );
		int __fastcall  getCellStyle( int x, int y );
		bool __fastcall	getOverline( int x, int y );
		bool __fastcall	getUnderline( int x, int y );
		bool __fastcall	getStrikeout( int x, int y );
		void __fastcall insertImage(imgPosition iPos, imgSize iSize, char * imgUrl);
		void __fastcall modifyImage(char * shapeName, imgPosition iPos, imgSize iSize);
		void __fastcall modifyImageById(int id, imgPosition iPos, imgSize iSize);
		int __fastcall	getImageCount( int iSheet );
		imgSize __fastcall getImageSize( int id );
		imgPosition __fastcall getImagePosition( int id );
		bool __fastcall setVerticalAlignment(int x, int y, short vert);

		

		//WRITER
		bool __fastcall connect2Writer(char *file, char * host, char * port, bool hidden, char * key);
		char * __fastcall getWText();
		void __fastcall setWText(char * text, int iStartAt = 0);
		bool __fastcall export2Writer(char * file);
		void __fastcall createTextTable();

		//IMPRESS
		bool __fastcall connect2Impress(char *file, char * host, char * port, bool hidden, char * key);
		bool __fastcall export2Impress(char * file);
};


#endif